<?php
/***************************************************************************
 *                              admin_ranks.php
 *                            -------------------
 *   begin                : Thursday, Jul 12, 2001
 *   copyright            : (C) 2001 The phpBB Group
 *   email                : support@phpbb.com
 *
 *   $Id: admin_ranks.php,v 1.13.2.3 2002/11/28 00:11:39 psotfx Exp $
 *
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/

define('IN_PHPBB', 1);

if( !empty($setmodules) )
{
	$file = basename(__FILE__);
	$module['Users']['Rank_Genres'] = "$file";
	return;
}

//
// Let's set the root dir for phpBB
//
$phpbb_root_path = "./../";
require($phpbb_root_path . 'extension.inc');
require('./pagestart.' . $phpEx);

$template->set_filenames(array(
	"body" => "admin/rank_genres_list_body.tpl")
);


$rgenre = array();
$rgenre_id = array();
$rgenre_name = array();
$level_max = 0;

/*
	Ranks genres are categorised into directories in the filesystem, and within each directory
	there are numbered images.
	Hence a simple example structure is:
	
	|- 1 Angst
	|	|- 1 Whiny
	|	|- 2 Tragic
	|	\- 3 Traumatised and Allegorical
	|
	|- 2 Cute
	|	|- 1 Too Cool to be Cute
	|	|- 2 Super Deformed
	|	\- 3 Sweet like Sugar
	|
	
	The categories are Angst and Cute, the number are the categories index in the database,
	the levels of images are given by the number. The number of posts needed is given by
	the normal Ranks admin page, where you name levels 0, 1, 2, 3 for the above example.
	Level 0 does not have an image, so none is shown next to the user, useful for giving
	established members a feeling of 'priviledge'.
*/

$root = $phpbb_root_path . "images/ranks";
$dir = @opendir($root);

while( $file = @readdir($dir) )
{
	if( !preg_match("/^.*?\.(gif|jpg)$/", $file) )
	{
		if($file == '.' || $file == '..'){continue;}

		preg_match("/^(\d+) (.*)/", $file, $matches);
		array_push($rgenre_id, $matches[1]);
		array_push($rgenre_name, $matches[2]);

		// Open another dir object to ensure we don't move the file pointer in @readdir($dir)
		$dir2 = @opendir($root . "/" . $file);

		$temp = array();
		array_push($temp, $matches[2]);
		while( $file2 = @readdir($dir2))
		{
			if($file2 == '.' || $file2 == '..'){continue;}
			preg_match("/^(\d+) (.*)\.(jpg|gif)/", $file2, $matches2);
			array_push($temp, "<img src=\"$root/$file/$file2\" alt=\"$matches2[2]\" title=\"$matches2[2]\"></img><br>\n<span class=\"gensmall\">$matches2[2]</span>");
			if($matches2[1]>$level_max){$level_max = $matches2[1];}
		}
		array_push($rgenre ,$temp);

		@closedir($dir2);
	}
}

@closedir($dir);



$sql_list = array();
array_push($sql_list, 'TRUNCATE TABLE ' . RANK_GENRES_TABLE);
array_push($sql_list, 'INSERT INTO ' . RANK_GENRES_TABLE . ' (rank_genre_id, rank_genre_name) VALUES (0, \'\')');

foreach($rgenre_id as $i => $id)
{
	array_push($sql_list, 'INSERT INTO ' . RANK_GENRES_TABLE . " (rank_genre_id, rank_genre_name) VALUES ($rgenre_id[$i], '$rgenre_name[$i]')");
}

foreach($sql_list as $sql)
{
	if( !$result = $db->sql_query($sql) )
	{
		message_die(GENERAL_ERROR, "Couldn't insert rank genre data", "", __LINE__, __FILE__, $sql);
	}
}
foreach($rgenre as $entry){
	$template->assign_block_vars("tr_loop", array( "genre" => $entry[0]));
	
	// NB This loop skips the first column, as that is the genre name (see above)
	for ( $i = 1; $i < $level_max+1; $i++ )
	{
		 $template->assign_block_vars('tr_loop.td_loop',array(
			'img' => $entry[$i]
		 ));
	}
}

// Prepare centre colums (first and last columns have a different class in the template,
// and hence must be distinguishable). The first column template variable is L_RGENRE_GENRE
for ( $i = 0; $i < $level_max-1; $i++ )
{
     $template->assign_block_vars('th_loop',array(
     	'LEVEL' => ($i + 1)
	 ));
}
// Take care of the last column
$template->assign_var('th_last', $level_max);



$template->assign_vars(array(
	'L_RGENRE_TITLE' 		=> $lang['RGenre_title'],
	'L_RGENRE_EXPLAIN' 		=> $lang['RGenre_explain'],
	'L_RGENRE_INSTRUCTIONS' => $lang['RGenre_instructions'],
	'L_RGENRE_NOTE' 		=> $lang['RGenre_note'],
	'L_RGENRE_GENRE' 		=> $lang['RGenre_genre'],
	'L_RGENRE_LEVEL' 		=> $lang['RGenre_level']
));

$template->pparse("body");

include('./page_footer_admin.'.$phpEx);

?>
